#!/usr/bin/perl
use strict;

# On CSAIL Debian, there are no boost debug packages.  This script 
# fixes the makefiles so that they use the optimized version of the
# precompiled boost libraries instead of the debug version.

my @makefiles = grep { chomp; 1 } `find . -name Makefile`;
foreach my $m (@makefiles) {
    open IN, $m;
    open OUT, ">$m.tmp";
    while (my $line = <IN>) {
        $line =~ s/-gcc-d-/-gcc-/g;
        print OUT $line;
    }
    close(IN);
    close(OUT);
    `mv $m.tmp $m`;
}
