#ifndef _LEAR_ALIGN_IN_IMAGE_H_
#define _LEAR_ALIGN_IN_IMAGE_H_

#include <string>
#include <lear/classifier/ppresult.h>
#include <lear/classifier/histprocessor.h>
#include <blitz/tinyvec.h>

namespace lear {
  struct AlignInImage : public PostProcessResult, public HistProcessor{
    typedef PostProcessResult           Parent;
    typedef blitz::TinyVector<int,2>    IndexType;
    AlignInImage(std::string const outimage_,
                 bool const outfileIsDir_,
                 IndexType const margin_,
                 IndexType const normalsize_,
                 std::string const &histfile_="",
                 RealType const minTh_ = -20,
                 RealType const extTh_ = 40, 
                 RealType const bandwidth_ = 0.01);

    virtual void write(const_iterator s, const_iterator e, 
                       RGBImage    const &inimage,
                       std::string const &infile);

    virtual std::string toString() { 
      return "Align Input Image Post Process Result";
    }
  protected:
    std::string const outimage_;
    bool const outfileIsDir_;
    IndexType const margin_,normalsize_;
  };
}
#endif // _LEAR_ALIGN_IN_IMAGE_H_
