#ifndef _LEAR_LIST_POST_PROCESS_RESULT_H_
#define _LEAR_LIST_POST_PROCESS_RESULT_H_

#include <fstream>
#include <lear/classifier/ppresult.h>
namespace lear {
  struct List_PPResult : PostProcessResult {
    typedef PostProcessResult                       Parent;

    List_PPResult(std::string const &listfile_, const int marker=1,
                  bool const writeFilename=false, int const verbose=0);
    virtual ~List_PPResult() {}

    /** Write detection results, must be invoked after invoking
     *  operator() on all tested window to write corresponding detection 
     *  results. 
     */
    virtual void write(const_iterator s, const_iterator e, 
                       RGBImage    const &inimage,
                       std::string const &infile);

    virtual std::string toString() { 
      return "List Post Process Result";
    }
  protected:
    std::ofstream to;
    int  const    marker;
    bool const    writeFilename;
    int  const    verbose;
  };

}
#endif // _LEAR_LIST_POST_PROCESS_RESULT_H_
