#include <pdcuda/threads.h>

#include <boost/thread/thread.hpp>
#include <boost/thread/mutex.hpp>

using namespace boost;

pdcuda::Mutex::Mutex() 
  : m(NULL) 
{
  m = new mutex();
}

pdcuda::Mutex::~Mutex() {
  delete static_cast<mutex*>(m);
}

pdcuda::ScopedLock::ScopedLock(Mutex &m) 
  : m(m), l(NULL) 
{
  l = new mutex::scoped_lock(*static_cast<mutex*>(m.m));
}

pdcuda::ScopedLock::~ScopedLock() {
  delete static_cast<mutex::scoped_lock*>(l);
}
