/* standard headers */
#include <iostream>
#include <sstream>
#include <lear/image/pimage.h>
#include <lear/exception.h>
#include <lear/image/imageio.h>

using namespace lear;
PImage::PImage(int w, int h, int depth) 
#ifdef WIN32
: imageIsValid(false) 
#endif
{
#ifndef WIN32
  Imlib_Image image = imlib_create_image(w,h);
  if (!image){
    ThrowException("Unable to create image");
  }
#else
  if (SUCCEEDED(image.Create(w,h,depth*8))) {
    imageIsValid = true;
  } else {
    ThrowException("Unable to create image");
  }
#endif
}
void PImage::load(std::string const &imagename) {
#ifndef WIN32
  // an image handle 
  image = imlib_load_image(imagename.c_str());;
  // if the load was successful
  if (!image){
    ThrowException("Unable to load image " + imagename);
  }
#else
  image.Destroy();
  CString n(imagename.c_str());
  HRESULT hr = image.Load(n);
  imageIsValid = SUCCEEDED(hr);
  if (!imageIsValid) {
    ThrowException("Unable to load image " + imagename);
  }
#endif
}
