#ifndef PDCUDA_GRADIENTS_H
#define PDCUDA_GRADIENTS_H

#include "../lib/cfg.h"

namespace pdcuda 
{
  static bool const SemiCirc = true; // non-semicircle not implemented now

  static float const GradientSmoothingScale = 0.f; // no smoothing implemented right now

#ifdef HAVE_CUDA
  // Compute the spatial gradients at every pixel location.  The
  // output is in polar coordinates.  Inputs and outputs are
  // non-padded (packed) row-major device pointers.  An unsmoothed
  // central first difference operator is used.  For each RGB pixel,
  // the gradient data with the largest magnitude is selected.
  //
  // This function is NOT threadsafe.
  void computeSpatialGradients(float *dMag, float *dOri, float const *dRgb, 
                               int w, int h);
#endif

};
#endif
