#ifndef PDCUDA_TYPES_GOLD_H
#define PDCUDA_TYPES_GOLD_H

#include <blitz/array.h>

#include <lear/cvision/iprocessor.h>
#include <lear/cvision/dhistogram.h>
#include <lear/cvision/phistogram.h>

#include "rhogdense.h"
#include "transposedarrays.h"

namespace pdcuda {

  typedef lear::IProcessor::RealType           RealType;

  typedef lear::IProcessor::RGBImage           RGBImage;    // Array<TinyVector<float,3>,2>
  typedef lear::IProcessor::GrayImage          GrayImage;   // Array<float,2>
  typedef lear::IProcessor::InfoType::MagAType Magnitude;   // Array<float,2>
  typedef lear::IProcessor::InfoType::OriAType Orientation; // Array<int,2>
  typedef blitz::Array<float,2>                OrientationF;

  typedef pdcuda::TransposedDeviceArray2D<float> TMagnitude;
  typedef pdcuda::TransposedDeviceArray2D<float> TOrientation;

  typedef lear::PrecisionHistogram<RealType,RealType,3> Histogram;
  //typedef lear::DiscreteHistogram<RealType,RealType,3> Histogram;

  typedef blitz::Array<float,5> BlockDescriptors; // (cy,cx,bin,y,x): last dim is most contiguous

  typedef blitz::TinyVector<int,2>  IndexType;

  typedef blitz::Array<float,2>                  ScoreMap;
  typedef pdcuda::TransposedDeviceArray2D<float> TScoreMap;

  typedef blitz::TinyVector<float,WinDescLen> FeatureVector;

};

#endif
