%                       basedir            annoset     w  fh  fTop ip op  maxOccl
%                       -----------------  ----------  -- --  ---- -- --  -------------
extractPositiveExamples(inriaDir('train/inria'), '20080211', 32,96, 1,   16,16, [1/3 1/2 3/4])
extractPositiveExamples(inriaDir('train/inria'), '20080211', 32,96, 1/2, 16,16, [1/3 1/2 3/4])
extractPositiveExamples(inriaDir('train/inria'), '20080211', 32,96, 1/3, 16,16, [1/3 1/2 3/4])
extractPositiveExamples(inriaDir('train/inria'), '20080211', 32,96, 1/4, 16,16, [1/3 1/2 3/4])

extractPositiveExamples(inriaDir('test/inria'), '20080211', 32,96, 1,   16,16, [])
extractPositiveExamples(inriaDir('test/inria'), '20080211', 32,96, 1/2, 16,16, [])
extractPositiveExamples(inriaDir('test/inria'), '20080211', 32,96, 1/3, 16,16, [])
extractPositiveExamples(inriaDir('test/inria'), '20080211', 32,96, 1/4, 16,16, [])

extractPositiveExamples(grandCentralDir('test/1159407741750'), '20080221', 32,96, 1,   16,16, [1/3 1/2 3/4], 1)
extractPositiveExamples(grandCentralDir('test/1159407741750'), '20080221', 32,96, 1/2, 16,16, [1/3 1/2 3/4], 1)
extractPositiveExamples(grandCentralDir('test/1159407741750'), '20080221', 32,96, 1/3, 16,16, [1/3 1/2 3/4], 1)
extractPositiveExamples(grandCentralDir('test/1159407741750'), '20080221', 32,96, 1/4, 16,16, [1/3 1/2 3/4], 1)

extractPositiveExamples(grandCentralDir('test/20061026-metlife'), '20080221', 32,96, 1,   16,16, [1/3 1/2 3/4], 1)
extractPositiveExamples(grandCentralDir('test/20061026-metlife'), '20080221', 32,96, 1/2, 16,16, [1/3 1/2 3/4], 1)
extractPositiveExamples(grandCentralDir('test/20061026-metlife'), '20080221', 32,96, 1/3, 16,16, [1/3 1/2 3/4], 1)
extractPositiveExamples(grandCentralDir('test/20061026-metlife'), '20080221', 32,96, 1/4, 16,16, [1/3 1/2 3/4], 1)

extractPositiveExamples(grandCentralDir('test/20061026-metlife'), '20080221', 32,96, 1,   16,16, [1/3 1/2 3/4], 1)
extractPositiveExamples(grandCentralDir('test/20061026-metlife'), '20080221', 32,96, 1/2, 16,16, [1/3 1/2 3/4], 1)
extractPositiveExamples(grandCentralDir('test/20061026-metlife'), '20080221', 32,96, 1/3, 16,16, [1/3 1/2 3/4], 1)
extractPositiveExamples(grandCentralDir('test/20061026-metlife'), '20080221', 32,96, 1/4, 16,16, [1/3 1/2 3/4], 1)

% extract small chips and create aliases for various window geometries
origdir = pwd;
basedirs = { ...
  inriaDir('train/inria'),                  '20080211'; ...
  inriaDir('test/inria'),                   '20080211';...
  grandCentralDir('test/1159407741750'),    '20080221';...
  grandCentralDir('test/20061026-metlife'), '20080221' };
for bi=1:size(basedirs,1);
  basedir = basedirs{bi,1};
  annoset = basedirs{bi,2};
  extractPositiveExamples(basedir, annoset, 8,24, 1, 4,3, [])
  base = ['pos_' annoset '_w16x32c'];
  ext  = '_all.lst';
  srclst = [base '8x8' ext];
  assert(exist(fullfile(basedir,srclst),'file')~=0,...
    'Could not find %s in "%s"', srclst, basedir);
  
  % 2x2 and 4x4 have the same sided windows
  for c=[2 4]
    cmd = ['cd ' linuxPath(basedir) '; ln -s  ' srclst '  ' base sprintf('%dx%d',c,c) ext];
    if ispc
      fprintf('%s\n', cmd);
    else
      system(cmd);
    end
  end
  
  % 6x6 has a smaller window
  c = 6;
  base = ['pos_' annoset '_w12x30c'];
  cmd = ['cd ' linuxPath(basedir) '; ln -s  ' srclst '  ' base sprintf('%dx%d',c,c) ext];
  if ispc
    fprintf('%s\n', cmd);
  else
    system(cmd);
  end
end