baseindir     = appPath('/afs/csail/group/vision/app/data/video/grandcentral');
baseoutdir    = appPath('/afs/csail/group/vision/app/data/images/pedestrianDetection/grandcentral/test');
previsitindir = fullfile(baseindir, 'previsit');

if 0
  fprintf(['This script will completely delete\n   %s\n'...
           'Note that this script takes a very long time, at least on Windows.\n'...
           'Press Ctrl-C to prevent this from happening.\n'...
           'To proceed, press <ENTER>.'], baseoutdir);
  pause;
  try 
    rmdir(baseoutdir, 's'); 
  catch 
  end
  mkdir(baseoutdir);
end

deleteAllJobs % Gerald's job scheduler

% previsit videos
previds = {...
  '1157719419546', '1157719641656', '1159407741750', ...
  '1161257763406 7.30am', '1161259437437.8.03am'
  };
for i = 1:length(previds)
  previd = previds{i};
  ext    = '.xvid.1000k.avi';
  infile = fullfile(previsitindir, [previd ext]);
  outdir = fullfile(baseoutdir, strrep(strrep(previd, '_',''), ' ', '-'), 'full');
  if ~exist(outdir, 'dir')
    addJobs(sprintf(...
        'sampleFramesFromOneVideo(''%s'', ''%s'', 25);', infile, outdir));
  end
end
previd = '1159407741750';
ext    = '.xvid.1000k.avi';
infile = fullfile(previsitindir, [previd ext]);
outdir = fullfile(baseoutdir, strrep(strrep(previd, '_',''), ' ', '-'), 'full');
if ~exist(outdir, 'dir')
    addJobs(sprintf(...
        'extractIntroSequenceFromOneVideo(''%s'', ''%s'', 25);', ...
        infile, outdir));
end

% APP capture experiments
vids = {...
  '20061026/metlife.xvid.2000k.avi',                             '20061026-metlife',...
  '20061026/westwall.mpeg4.2000k.avi',                           '20061026-westwall',...
  '20080619/eastwall-0645/mpeg4.quant02.avi',                    '20080619-0645-eastwall',...
  '20080620/eastwall-0751/mpeg4.quant02.avi',                    '20080620-0751-eastwall',...
  '20080620/eastwall-1347/mpeg4.quant02.avi',                    '20080620-1347-eastwall',...
  '20080826/westwall-tall-0930/mpeg4.quant02.avi',               '20080826-0930-westwall-tall',...
  '20080827/westwall-tall-0921/mpeg4.quant02.avi',               '20080827-0921-westwall-tall',...
  '20080619/westwall-0710/westwall-2008_06_19-07_10_07.mpg',     '20080619-0710-westwall',...
  '20080620/westwall-0742/westwall-2008_06_20-07_42_21.mpg',     '20080620-0742-westwall',...
  '20080620/westwall-1353/westwall-2008_06_20-13_53_48.mpg',     '20080620-1353-westwall',...
  ...%'20080620/westwall-1406/westwall-2008_06_20-14_06_14.mpg',     '20080620-1406-westwall',...
  '20080826/westwall-wide-0930/westwall-2008_08_26-09_30_58.mpg', '20080826-0930-westwall-wide',...
  '20080827/westwall-wide-0921/westwall-2008_08_27-09_21_14.mpg', '20080827-0921-westwall-wide',...
  };
for i = 1:2:length(vids)
  infile = fullfile(baseindir, vids{i});
  outdir = fullfile(baseoutdir, vids{i+1}, 'full');
  deint  = ~isempty(strfind(infile, 'metlife'));
  if ~exist(outdir, 'dir')
    addJobs(sprintf(...
        'extractIntroSequenceFromOneVideo(''%s'', ''%s'', %d, %d);',...
        infile, outdir, 100, deint));
    addJobs(sprintf(...
        'sampleFramesFromOneVideo(''%s'', ''%s'', %d, %d);',...
        infile, outdir, 25, deint));
  end
end
