function filtered = arrayfilt(fun,c)
%filtered = arrayfilt(fun,c)
%  Filters an array C.  Function FUN is evaluated on each element of C.
%  If FUN's value is true, the element of C is retained, otherwise it is
%  discarded.  FILTERED holds the retained values.  
%
%  ARRAYFILT is to Scheme's FILTER as ARRAYFUN is to Scheme's MAP.
%
%  TODO: alternatively, allow FUN to be an indicator vector or an index
%  vector.
%

keepers = false(size(c));
for i=1:numel(c)
  truthVal = fun(c(i));
  keepers(i) = ~isempty(truthVal) && logical(truthVal);
end
filtered = c(keepers);

% Old implementation: doesn't work with functions that return empty
% matrices.
%keepers = logical(cellfun(fun,c));
%filtered = {c{keepers}};
