function leg = thesisLegend(expts,fields)

N = length(expts);
leg = cell(1,N);

[leg,fields] = handleField(0, @upper,                   'train','imageset', expts,leg,fields);
[leg,fields] = handleField(0, @xTrainAnnoset,           'train','annoset',  expts,leg,fields);
[leg,fields] = handleField(0, @xPass,                   'train','pass',     expts,leg,fields);
[leg,fields] = handleField(0, @(i) [' (' upper(i) ')'], 'train','impl',     expts,leg,fields);

if ~isempty(fields)
  error('Unknown fields: %s',join(',', fields));
end

%--------------------------------------------------------------------------
function [leg,fields] = handleField(replacer, handler, phase,field, expts,leg,fields)
N = length(expts);
f = join('.', phase, field);
if ismember(f, fields)
  for i=1:N
    if replacer
      leg{i} = handler(leg{i}, expts(i).(phase).(field));
    else
      leg{i} = cat(2, leg{i}, handler(expts(i).(phase).(field)));
    end
  end
  fields = setdiff(fields, f);
end

%--------------------------------------------------------------------------
function out = xTrainAnnoset(annoset)
if strcmp(annoset, 'orig')
  out = '-orig';
elseif strcmp(annoset, '20080211')
  out = '-new';
else
  error('unknown annoset: "%s"', annoset);
end

%--------------------------------------------------------------------------
function out = xPass(pass)
if strcmp(pass, 'firstPass')
  out = '';
elseif strcmp(pass, 'hard')
  out = ' + hard';
elseif strcmp(pass, 'persp')
  out = ' + hard + GrandCentral';
else
  error('Unknown pass: %s', pass);
end